<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>EventExecutor.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean</a> &gt; <span class="el_source">EventExecutor.java</span></div><h1>EventExecutor.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean;

import com.littlesaints.protean.functions.streams.Try;
import com.littlesaints.protean.functions.trial.FnTrial;
import com.littlesaints.protean.functions.trial.Strategy;
import io.gitlab.littlesaints.protean.analytics.StatsListener;
import io.gitlab.littlesaints.protean.configuration.ExecutorOptions;
import io.gitlab.littlesaints.protean.event.EventAccessor;
import io.gitlab.littlesaints.protean.event.State;
import io.gitlab.littlesaints.protean.resources.Registry;

import java.util.function.*;

/**
 * An interface for executors that common and run the execution workflow / pipeline as defined in a {@link Context}.
 *
 * @author Varun Anand
 * @since 1.0
 */
public interface EventExecutor&lt;P, R&gt; {

	/**
	 * Repository for all configured executors.
	 */
<span class="fc" id="L45">	Registry&lt;Factory&gt; REGISTRY = new Registry&lt;&gt;();</span>

	/**
	 * Submit a payload for execution.
	 *
	 * @param payload     the object to execute on.
	 */
	R execute(final P payload);

	static &lt;E&gt; boolean filter(E e, boolean skippable, Predicate&lt;E&gt; filter, Function&lt;E, State&gt; stateResolver) {
<span class="pc bpc" id="L55" title="1 of 4 branches missed.">		return filter(e, skippable, stateResolver) &amp;&amp; filter(e, filter);</span>
	}

	static &lt;E&gt; boolean filter(E e, boolean skippable, Function&lt;E, State&gt; stateResolver) {
<span class="fc bfc" id="L59" title="All 4 branches covered.">		return stateResolver.apply(e) == State.SUCCESS || !skippable;</span>
	}

	static &lt;E&gt; boolean filter(E e, Predicate&lt;E&gt; filter) {
<span class="pc bpc" id="L63" title="3 of 4 branches missed.">		return filter == null || filter.test(e);</span>
	}

	static &lt;E&gt; Function&lt;E, State&gt; newExecutionOp(Function&lt;E, State&gt; processor, BiFunction&lt;E, Exception, State&gt; exceptionHandler,
                                            Strategy retryStrategy) {
        final Function&lt;E, State&gt; op;
<span class="fc bfc" id="L69" title="All 2 branches covered.">        if (exceptionHandler == null) {</span>
<span class="fc" id="L70">            op = processor;</span>
        } else {
<span class="fc" id="L72">            op = Try.evaluate(processor::apply).onException(exceptionHandler);</span>
        }
<span class="pc bpc" id="L74" title="1 of 2 branches missed.">        if (retryStrategy == null) {</span>
<span class="nc" id="L75">            return op;</span>
        } else {
<span class="fc bfc" id="L77" title="All 2 branches covered.">            return FnTrial.of(retryStrategy.toBuilder().build(), op, s -&gt; s != State.RETRY, s -&gt; State.FAILURE);</span>
        }
    }

	static &lt;E&gt; void process(Function&lt;E, State&gt; executionOp, E e,
                            Function&lt;E, State&gt; stateResolver, BiConsumer&lt;E, State&gt; stateRegistrar) {
<span class="fc" id="L83">	    State state = executionOp.apply(e);</span>
<span class="fc bfc" id="L84" title="All 4 branches covered.">		if (stateResolver.apply(e) == State.SUCCESS &amp;&amp; state != State.SUCCESS) {</span>
<span class="fc" id="L85">			stateRegistrar.accept(e, state);</span>
		}
<span class="fc" id="L87">	}</span>

	void shutdown();

	/**
	 * The factory method for all implementations.
	 * This method will be configured in {@link #REGISTRY} to facilitate lookup and creation of instance by their {@link String} getType.
	 */
	interface Factory {
		&lt;E, P, R&gt; EventExecutor&lt;P, R&gt; newInstance(final String contextName, final ExecutorOptions options, final Supplier&lt;E&gt; constructor, final Graph&lt;E&gt; graph,
											final BiConsumer&lt;E, P&gt; initializer, final Consumer&lt;E&gt; ackListener, final EventAccessor&lt;E, P&gt; eventAccessor,
											final StatsListener&lt;E&gt; statsListener, final boolean cleanShutdown, final Function&lt;E, R&gt; resultResolver);
	}

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>